module camera (clk,pixclk,href,vsync,datain,pixelout,pixelready,pixloc,mon_h,mon_v,mon_p);
input wire clk,pixclk;
output reg [24:0] pixloc;
input wire href,vsync;
input reg [7:0] datain;
output reg [7:0]pixelout;
output reg pixelready;
output reg mon_h,mon_v,mon_p;
reg other;
reg st1,st2,st3,st4;
reg eveninit,oldpixclk,oldvsync,oldhref;//vsyncreg;
reg even;
reg delay1,delay2;

reg [19:0]linecount;
reg [13:0] hcount,vcount;
reg [24:0] framecount,lineloc;
reg [5:0] camstate;

assign mon_p = pixclk;
assign mon_h = href;
assign mon_v = vsync;
//assign vsyncreg=vsync;
initial
begin
  eveninit = 1;
  pixloc=0;
  pixelready=0;
  linecount=0;
  st1=0;
  st2=0;
  st3=0;
  st4=0;
  hcount=0;
  vcount=0;
  framecount=0;
  even=1;
  lineloc=0;
end



always@(posedge clk)
begin
  oldpixclk<=pixclk;
  oldhref<=href;
  oldvsync<=vsync;
  st2<=st1;
  st3<=st2;
  camstate<= {vsync,oldvsync,href,oldhref,pixclk,oldpixclk};
  if (st2==1)begin pixelready<=0;st1<=0;  end
  casex(camstate)
  // {vsync,oldvsync,href,oldhref,pixclk,oldpixclk} 
	 6'b01xxxx :      //vsync
	         
				begin
				if (vcount>638)
		 	    begin
	            pixelready<=0; 
					vcount<=0;
					hcount<=0;
					even<=eveninit;
					st1<=0;
					
					pixloc<=0;
					lineloc<=0;
				  end
			   end
    
	 6'b001x01 : //if linevalid(href) and negative edge of pixel clock
	             begin
					   if (even==1)begin even<=0;end
						if (even==0)begin even<=1;end
					   if ((vcount<240)&&(hcount<320)) 
						 begin
						    //  even<= !even;
								pixelout<=datain;
								pixelready<=even;
								st1<=1; 
								hcount<=hcount+ even;
								pixloc<=lineloc+hcount;
							 end
	             end
					 
	  // {vsync,oldvsync,href,oldhref,pixclk,oldpixclk} 

	6'b0001xx  :     //at negative edge of href
               	begin
						
						
	                 hcount<=0;
						  vcount<=vcount+1;
						  if (lineloc<150000)begin lineloc<=lineloc+640;end
						 // even<=eveninit;
						
	               end
	            
	 default    : other<=1;
	 endcase

  end

endmodule